/**
 * Infrared-Network OBEX Bridge for OBEX Library.
 * Copyright(C) 2002,2003 by KEI SAKAKI.
 * 
 * AvJc[ŎۂɐԊOʐMs߂̃ubWs\tgEFAłB
 * ȃf[^ʉ߂Ƃꂾ̂ŒӂKvłB
 * ȏ̂悤Ȏdl̂߁AJړIȊOɂ͎gpł܂B
 */

import java.io.*;
import java.net.*;
import java.util.*;

import personal.sakaki.io.*;

// inbridge server		ԊOT[o[̏ꍇ
// inbridge client		ԊONCAg̏ꍇ

public class inbridge
{
	public static void main(String[] args)
	{
		System.out.println("Infrared-Network OBEX Bridge for OBEX Library\n" + 
						   "Copyright(C) 2002,2003 by KEI SAKAKI.\n" +
						   "ALL RIGHTS RESERVED.\n");
		
		boolean fHelp = (args.length == 0);

		boolean fServer = !fHelp && args[0].toLowerCase().equals("server");
		if(!fHelp && !fServer && !args[0].toLowerCase().equals("client")) {
			fHelp = true;
		}
		
		if(!fHelp && fServer && args.length > 2) fHelp = true;
		if(!fHelp && !fServer && args.length > 3) fHelp = true;
		
		if(args.length == 0 || (args[0].toLowerCase().equals("server") && args[0].toLowerCase().equals("client"))) {
			System.out.println("ԊOT[o[Ƃꍇ\n" +
							   "    java inbridge server [port]\n" + 
							   "\n" +
							   "ԊONCAgƂꍇ\n" +
							   "    java inbridge client [address] [port]");
			return;
		}
		
		if(args[0].toLowerCase().equals("server")) {
			// T[o[

			int nPort = 650;
			
			if(args.length == 2) {
				try {
					nPort = Integer.parseInt(args[1]);
					
					if(nPort > 65535) throw new NumberFormatException();
				} catch(NumberFormatException e) {
					System.out.println("|[gԍɕsȒl" + args[1] + "w肳܂B");
					System.exit(1);
				}
			}

			while(true) {
			
				ServerSocket ss = null;
			
				try {
					ss = new ServerSocket(nPort);
				} catch(IOException e) {
					System.out.println("lbg[Ñ|[g" + nPort + "J܂łB");
					System.exit(1);
				}

				ObexServerConnection os = null;
				try {
					os = ObexManager.getServer("TCP/IP", ss);
				} catch(ObexException e) {
					System.out.println("T[o[IuWFNg̎擾Ɏs܂B");
					System.out.println("X^bNg[X");
					e.printStackTrace();
					System.exit(1);
				}
				ObexClientConnection oc = null;
				try {
					oc = ObexManager.getClient("IrDA");
				} catch(ObexException e) {
					System.out.println("NCAgIuWFNg̎擾Ɏs܂B");
					System.out.println("X^bNg[X");
					e.printStackTrace();
					System.exit(1);
				}
			
				bridge(os, oc, "lbg[N", "ԊO");	
				
				try {
					os.close();
				} catch(ObexException ignore) { }
				
				try {
					oc.close();
				} catch(ObexException ignore) { }
				
				try {
					ss.close();
				} catch(IOException ignore) { }
			}
		} else {
			// NCAg

			String strAddress = "localhost";
			int nPort = 650;
			
			if(args.length > 1) {
				strAddress = args[1];
			}
			
			if(args.length == 3) {
				try {
					nPort = Integer.parseInt(args[2]);
					
					if(nPort > 65535) throw new NumberFormatException();
				} catch(NumberFormatException e) {
					System.out.println("|[gԍɕsȒl" + args[2] + "w肳܂B");
					System.exit(1);
				}
			}

			while(true) {
			
				Socket s = null;
			
				try {
					s = new Socket(strAddress, nPort);
				} catch(IOException e) {
					System.out.println("lbg[N̐ڑ" + strAddress + "̃|[g" + nPort + "ɐڑł܂łB");
					System.exit(1);
				}

				ObexServerConnection os = null;
				try {
					os = ObexManager.getServer("IrDA");
				} catch(ObexException e) {
					System.out.println("T[o[IuWFNg̎擾Ɏs܂B");
					System.out.println("X^bNg[X");
					e.printStackTrace();
					System.exit(1);
				}
				ObexClientConnection oc = null;
				try {
					oc = ObexManager.getClient("TCP/IP", s);
				} catch(ObexException e) {
					System.out.println("NCAgIuWFNg̎擾Ɏs܂B");
					System.out.println("X^bNg[X");
					e.printStackTrace();
					System.exit(1);
				}
			
				bridge(os, oc, "ԊO", "lbg[N");	
				
				try {
					os.close();
				} catch(ObexException ignore) { }
				
				try {
					oc.close();
				} catch(ObexException ignore) { }
				
				try {
					s.close();
				} catch(IOException ignore) { }
			}
		}
	}

	/**
	 * ubW̃CłB
	 * @param	obexs	NGXg󂯕t鑤̃IuWFNgn܂B
	 * @param	obexc	NGXg𑗐M鑤̃IuWFNgn܂B
	 * @param	strReceive	NGXg󂯂鑤̕\n܂B
	 * @param	strTarget	NGXg𑗐M鑤̕\n܂B
	 */
	static void bridge(ObexServerConnection obexs, ObexClientConnection obexc, String strReceive, String strTarget)
	{
		while(true) {
			System.out.println(strReceive + "ڑ҂łB");
			try {
				obexs.accept();
			} catch(ObexException e) {
				System.out.println("ڑ҂Ɏs܂B");
				System.out.println("X^bNg[X");
				e.printStackTrace();
				System.exit(1);
			}
				
			System.out.println(strTarget + "ڑłB");
			try {
				obexc.connect();
			} catch(ObexException e) {
				System.out.println("ڑɎs܂B");
				System.out.println("X^bNg[X");
				e.printStackTrace();
				System.exit(1);
			}
				
			try {
				while(true) {
					System.out.println(strReceive + "NGXg҂łB");
					obexs.receiveRequest();

					int nOperation = obexs.getOperation();
						
					obexc.setOperation(nOperation);
						
					try {
						obexc.setDescription(obexs.getDescription());
					} catch(RuntimeException ignore) { }
						
					try {
						obexc.setName(obexs.getName());
					} catch(RuntimeException ignore) { }
						
					try {
						obexc.setTime(obexs.getTime());
					} catch(RuntimeException ignore) { }
						
					try {
						obexc.setType(obexs.getType());
					} catch(RuntimeException ignore) { }
						
					InputStream is = null;
					OutputStream os = null;

					if(nOperation == ObexConnection.PUT) {
						try {
							byte[] buff = new byte[obexs.getContentLength()];
						
							is = obexs.openInputStream();
							os = obexc.openOutputStream();
						
							is.read(buff);
							os.write(buff);
						
							os.close();
							is.close();
						} catch(RuntimeException e) {
							System.out.println("BODYwb_ɂf[^܂łB");
						} catch(IOException e) {
							System.out.println("\ȂIOExceptionONXthrow܂B");
							System.out.println("X^bNg[X");
							e.printStackTrace();
							System.exit(1);
						}
					}
					
					System.out.println(strTarget + "ɃNGXg𑗐MłB");
					obexc.sendRequest();
					
					if(nOperation == ObexConnection.GET) {
						try {
							byte[] buff = new byte[obexc.getContentLength()];
							
							is = obexc.openInputStream();
							os = obexs.openOutputStream();
							
							is.read(buff);
							os.write(buff);
							
							os.close();
							is.close();
						} catch(RuntimeException e) {
							System.out.println("BODYwb_ɂf[^܂łB");
						} catch(IOException e) {
							System.out.println("\ȂIOExceptionONXthrow܂B");
							System.out.println("X^bNg[X");
							e.printStackTrace();
							System.exit(1);
						}
					}
				
					try {
						obexs.setDescription(obexc.getDescription());
					} catch(RuntimeException ignore) { }
					
					try {
						obexs.setName(obexc.getName());
					} catch(RuntimeException ignore) { }
					
					try {
						obexs.setTime(obexc.getTime());
					} catch(RuntimeException ignore) { }
					
					try {
						obexs.setType(obexc.getType());
					} catch(RuntimeException ignore) { }
					
					System.out.println(strReceive + "ɃX|X𑗐MłB");
					obexs.sendResponse(obexc.getResponseCode());
				}
			} catch(ObexException e) {
				if(e.getStatus() == ObexException.DISCONNECTED) {
					System.out.println("ڑ܂B");
				} else {
					System.out.println("OBEXɗOthrow܂B");
					System.out.println("X^bNg[X");
					e.printStackTrace();
				}
				return;
			}
		}
	}
}
